# some examples in this lecture are modified from "R for Everyone" by Jared Lander
# Intro to R

# Basic Math
1 + 1
 # You can type these lines in the console:
1 + 2+ 3
3 * 7 * 2
4/2
4/3
#  R converts between "integer" and "numeric" for you
2^3  # exponentiation uses a carrot
2**3 # exponentiation can also use **


# Data Types
# Numeric
x<- 17  #assignment is 99.9% the same for both <- and =
y= 18
is.numeric(x)
y="hello"
is.numeric(y)

class(x)
class(y)
is.integer(x)
x=17L  # Note the "L".  That means an integer value
class(x)
a=3L
b=4L
b/a  #converts to a numeric

#even when done explicitly:
4L/3L

# use the integer arithmetic operators: 
# x%%y is x mod y
# x%/%y is x integer divide y (rounded down)
c=b%/%a
c
class(c)


# character data:  character vs. factor
# character is just a vector of characters
# factors are cagtegorical data, where each value is one discrete "category"
# a.k.a "level" of the "factor" type.
a="hello"
class(a)
nchar(a) # you can't do that with factors.  More on factors soon below.

# dates:  Two useful date types are Date and POSIXct
# Date, stores a date. (attually number of days since 1/1/1970)
# POSIXct stores and date and time. (actually, number of seconds since 1/1/1970)
# so you can see the numeric value of a date too:

date1 = "2012-06-28"  #This should be recognized as a character
class(date1)
date1 = as.Date(date1)
class(date1)

date_num = as.numeric(date1)
date_num
class(date_num)


# logical values  TRUE (numerically a 1) and FALSE (numerically a 0)
# so you can do arithmetic with these values

TRUE * 3 # should equal 3, because it's 1 * 3
FALSE *3 # should equal 0, because it's 0 * 3

# logical comparisons:  ==  != <  >  <=  >=
# also AND and OR
# logical operators